{ file sssqtp.pas }
 
{  SSS - Simulation Subroutine Set. Version 1.00
   Copyright (C) M. A. Pollatschek 1990.  All rights reserved.
}
 
unit sss;
 
interface
 
uses crt;
 
const
   MAXD = 100;   (*  max no. of values to use for user defined distribution  *)
 
type
   user_arr = array[1..MAXD] of real;
 
(*********************library functions decleration***********************)
 
 
function  A(i :integer):real;
function  AIC(ir,i :integer):real;
function  AIQ(nq,ir,i :integer):real;
function  BE(theta,phi :real):real;
function  BI(n: integer; p: real):integer;
function  CD(x,p:user_arr; n:integer):real;
procedure CLEARQ(i :integer);
procedure CLEARS(i :integer);
procedure CREATE(time: real; id: integer);
procedure DISPOS;
function  DP(prob:user_arr; nval:integer):real;
function  ER(expon_mean :real;k :integer):real;
function  EX(mean :real):real;
function  GA(beta,alpha :real):real;
function  IDE:integer;
function  IDIC(ir :integer):integer;
function  IDIQ(nq,ir :integer):integer;
procedure INIQUE(max_q,max_attr,max_stat :integer);
procedure INISTA(n :integer;name :string;if_time_p,n_cells:integer;fl,cw:real);
function  NC:integer;
function  NCEN:integer;
function  NEIC(ir :integer):integer;
function  NEXTEV:integer;
function  NP(mean :real):integer;
function  NQ(nq1: integer):integer;
function  PRIQ(nq,ir :integer):real;
function  QAVG(i :integer):real;
function  QDC(i :integer):char;
function  QMAX(i :integer):real;
function  QMIN(i :integer):real;
function  QNUM(i :integer):real;
function  QSTD(i :integer):real;
procedure QUEUE(nq :integer; PRIORITY: real);
function  RA:real;
procedure REMVFC(ir: integer);
procedure REMVFQ(nq,ir: integer);
function  RL(mean,sd :real):real;
function  RN(mean,sd :real):real;
function  SAVG(i :integer):real;
procedure SCHED(time :real;ne,id :integer);
procedure SETA(i :integer; v :real);
procedure SETANT(y: integer);
procedure SETDEB(err :integer);
procedure SETIDE(id :integer);
procedure SETQDC(n :integer;disc :string);
procedure SETSEE( i :integer);
procedure SETT(t :real);
procedure SHOWQ(m: integer);
procedure SIMEND(time: real);
function  SMAX(i :integer):real;
function  SMIN(i :integer):real;
function  SNUM(i :integer):real;
function  SSTD(i :integer):real;
procedure SUMRY(fn :string);
function  T:real;
procedure TALLY(n :integer; observation :real);
function  TIC(ir :integer):real;
function  TR(minimum,mode,maximum :real):real;
function  UN(minimum,maximum :real):real;
function  WE(beta,alpha :real):real;
 
 